#import "ViewController.h"
#import <Masonry/Masonry.h>
#import <RATreeView/RATreeView.h>
#import "FatherTableViewCell.h"
#import "ChildTableViewCell.h"
#import "GroupFriend.h"

@interface ViewController ()<RATreeViewDataSource,RATreeViewDelegate>
@property (nonatomic,strong)RATreeView *treeView;
@property (nonatomic,strong)NSArray *items;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
   
    self.treeView=[RATreeView new];
    self.treeView.backgroundColor=[UIColor colorWithRed:153.0f/255.0f green:154.0f/255.0f blue:155.0f/255.0f alpha:1];
    self.treeView.delegate=self;
    self.treeView.dataSource=self;
    [self.treeView registerNib:[UINib nibWithNibName:@"FatherTableViewCell" bundle:[NSBundle mainBundle]] forCellReuseIdentifier:kFatherTableViewCell];
    [self.view addSubview:self.treeView];
    
    [self.treeView mas_makeConstraints:^(MASConstraintMaker *make) {
        
        make.top.equalTo(self.view.mas_top).offset(35);
        make.left.right.bottom.equalTo(self.view);
    }];
    
    GroupFriend *name1=[GroupFriend dataObjectWithName:@"see you again" children:nil];
    GroupFriend *f1=[GroupFriend dataObjectWithName:@"oldFriend" children:@[name1]];
    
    GroupFriend *name2=[GroupFriend dataObjectWithName:@"have been" children:nil];
    GroupFriend *name3=[GroupFriend dataObjectWithName:@"long day" children:nil];
    GroupFriend *f2=[GroupFriend dataObjectWithName:@"速度与激情7" children:@[name2,name3]];
    
    self.items=@[f1,f2];
    
    [self.treeView reloadData];
  
}
- (CGFloat)treeView:(RATreeView *)treeView heightForRowForItem:(id)item
{
    return 44;
}

- (BOOL)treeView:(RATreeView *)treeView canEditRowForItem:(id)item
{
    return NO;
}

- (UITableViewCell *)treeView:(RATreeView *)treeView cellForItem:(id)item
{
    GroupFriend *g=item;
    if(g.children.count>0)
    {
        FatherTableViewCell *cell=[treeView dequeueReusableCellWithIdentifier:kFatherTableViewCell];
        if(cell==nil)
        {
            cell=[[NSBundle mainBundle]loadNibNamed:@"FatherTableViewCell" owner:self options:nil].lastObject;
        }
        cell.value=g.name;
        
        return cell;
    }
    else
    {
        ChildTableViewCell *cell=[treeView dequeueReusableCellWithIdentifier:kChildTableViewCell];
        if(cell==nil)
        {
            cell=[[NSBundle mainBundle]loadNibNamed:@"ChildTableViewCell" owner:self options:nil].lastObject;
        }
        cell.child=g.name;
        
        return cell;
    }
    
    return nil;
}
- (NSInteger)treeView:(RATreeView *)treeView numberOfChildrenOfItem:(id)item
{
    if (item == nil) {
        return [self.items count];
    }
    
    GroupFriend *g = item;
    return [g.children count];
}

- (id)treeView:(RATreeView *)treeView child:(NSInteger)index ofItem:(id)item
{
    GroupFriend *g = item;
    if (item == nil) {
        return [self.items objectAtIndex:index];
    }
    
    return g.children[index];
}
-(void)treeView:(RATreeView *)treeView didSelectRowForItem:(id)item
{
    GroupFriend *g=item;
    NSLog(@"g.name %@",g.name);
}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
